/*
#asm
#define TILT_MIRROR 1
#endasm
*/
	struct RECT
	{
		unsigned char X,Y,Width,Height;	
	};

	struct VPORT
	{
		unsigned char Left,Top,Right,Bottom;	
	};

	struct GOBJ
	{
		int X,Y;			// A sprite 16 bites előjeles koordinátája.
		unsigned char SprInd;		// A sprite indexe az exportált munkamenetben
		unsigned char Flag;		// 0. bit: jelzi, hogy a sprite be van-e kapcsolva. 1. bit: jelzi, hogy a sprite saját palettát használ
		char *SprBackAddr;		// A sprite háttér mentése számára lefoglalt mem. blokk kezdőcíme. Ha nem kell menteni a hátteret akkor az értéke 0!
		char *SprPalAddr;		// A sprite palettájának címe. Ha nincs paletta, akkor értéke 0!
		int (*spritefunc)();		// A sprite kirajzoló rutin kezdőcíme
		unsigned char SprWidth;		// A sprite szélessége
		unsigned char SprHeight;	// A sprite magassága
		unsigned char SprIndRef;	// Sprite index referencia. Azért kell, hogy el tudjuk dönteni kell-e újra inicializálni a sprite alap adatait (pl. RawAddr)
		char *SprRawAddr;		// Az adott sprite forrás adatai
		char *SprScrAddr;		// A sprite vágás utáni kezdőcíme a képernyőn v. háttér bufferben
		unsigned char SprClipSkipRow;	// A sprite felső vágásánál ezen a változón tárolódik, hogy hány sort kell felül kihagynia a sprite kirajzolónak
		struct RECT SprClip;		// A sprite vágás utáni dimenziói
		struct RECT SprPrevClip;	// A sprite előző fázisban értelmezett vágás utáni dimenziói
		unsigned char SprClipFlag;	// A sprite vágási állapotát tárolja le a sprite kirakónak
	};

#define MAX_GOBJ 20

struct GOBJ gObjects[MAX_GOBJ];
struct GOBJ* oAddr[3];

char robot1Back[4*21];
char playerBack[3*28];
char chairBack[6*32];

unsigned char player_colors[8] = {0,192,255,0,0,0,0,0};
unsigned char robot_colors[8] = {0,3,204,255,0,0,0,0};

main()
{
	struct GOBJ *go;
	int i,robotXdelta,chairYdelta;

	go = gObjects;

	chairYdelta = 4;
	robotXdelta = 1;

	SetBorder(PAL_DARKPURPLE);

	DbInitGameLib(2, gObjects, MAX_GOBJ);

	DbAssignRenderToBuffer();
//	DbFillBox(5, 10, 64-10, 240-20, PAL_GRAY);
	DbSetViewPort(5,10,63-5,239-10);
	DbFillBox(0, 10, 64, 240/*-20*/, PAL_GRAY);
//	DbSetViewPort(0,0,63,239);

	DbFillBox(5, 20, 30, 180, PAL_DARKCYAN);
	DbCopyScreenRect(0, 0, 64, 240);

	oAddr[0] = DbInitGameObject(go,20,30,1,1, DbSprite16c8, playerBack,player_colors);
	oAddr[1] = DbInitGameObject(++go,10,48,0,1, DbSprite16c8, chairBack,0);
	oAddr[2] = DbInitGameObject(++go,20,70,2,1, DbSprite16c8, robot1Back,robot_colors);


	while(IsKeyPress(KEY_4)==0)
	{
		if(IsKeyPress(KEY_R)) DbCopyScreenRect(0, 0, 64, 240);

		if(IsKeyDown(JOY1_LEFT) && oAddr[0]->X > 0) oAddr[0]->X -= 1;
		if(IsKeyDown(JOY1_RIGHT) && oAddr[0]->X < 61) oAddr[0]->X += 1;
		if(IsKeyDown(JOY1_UP) && oAddr[0]->Y > 0) oAddr[0]->Y -= 2;
		if(IsKeyDown(JOY1_DOWN) && oAddr[0]->Y < 240-28) oAddr[0]->Y += 2;

		if((robotXdelta > 0 && oAddr[2]->X > 59) || (robotXdelta < 0 && oAddr[2]->X < 1))
		{
			robotXdelta *= -1;
			oAddr[2]->Flag ^= 128;
		}
		oAddr[2]->X += robotXdelta;

		if((chairYdelta > 0 && oAddr[1]->Y > 240-33) || (chairYdelta < 0 && oAddr[1]->Y < 1))  chairYdelta *= -1;
		oAddr[1]->Y += chairYdelta;

		DbRender();
	}



	DbCloseGameLib();
}

Szoroz(int a,int b)
{
	return a*b;
}




#asm   // A grafikus munkaasztalból importált adatok. NE VÁLTOZTASD MEG!
		;{	Enumerált sprite indexek. Célszerű a főprogram elejére másolni!
				enum	SPR_IND_ITEM_ARMCHAIR,
					SPR_IND_PLAYER,
					SPR_IND_ROBOT

		;}

	GfxBaseAddr		dw	SpriteCount-GfxBaseAddr,0,0

	;{   Sprite-ok adatai (Automatikusan beemelve!)
	SpriteCount		db 3
	SpriteIndexArray
				dw	0,162,248

	SpriteDataBuffer	ds	0,0
	DecompressBuffer	ds	0,0

	SpriteBaseAddr
	item_armchair
				db	6+128			; A sprite szélessége byte-okban
				db	32			; A sprite magassága
				db	0,3,12,204,252,255,0,63			; A sprite szín adatai
				db	0,7,119,152,0,4,68,152,0,4,84,152,0,116,84,112,144,0,69,85,64,144,0,69,85,64,144,7,149,87,144,4
				db	149,84,144,4,149,84,144,4,156,0,51,144,112,0,3,34,0,7,112,0,2,34,144,112,0,2,34,0,7,112,0,2
				db	34,144,112,0,2,34,0,5,112,0,50,34,144,112,0,146,144,112,0,34,32,144,112,0,34,32,144,112,0,34,32,147
				db	115,51,34,32,146,114,146,32,146,114,146,32,146,114,146,0,2,34,114,146,0,2,34,114,146,0,2,34,114,146,0,2
				db	34,114,146,0,2,34,114,146,0,2,34,114,146,0,2,34,114,146,0,1,151,112,1,0
	player
				db	3			; A sprite szélessége byte-okban
				db	28			; A sprite magassága
				db	0,1,16,0,1,32,0,2,32,0,2,32,0,2,0,0,18,0,0,34,0,0,34,0,0,33,0,0,33,0,0,34
				db	0,1,34,0,1,18,32,1,16,34,1,17,2,1,17,0,1,17,16,1,17,16,0,17,16,0,16,17,1,16,17,1
				db	17,16,1,1,16,17,1,16,16,1,0,16,17,0,16,17,0,17,1,16
	robot
				db	4			; A sprite szélessége byte-okban
				db	21			; A sprite magassága
				db	0,32,144,0,32,144,3,51,0,16,17,51,3,16,153,16,3,51,3,16,0,3,0,16,0,51,48,0,1,49,49,0
				db	155,48,19,35,35,16,19,50,51,48,155,16,51,17,19,48,19,17,19,16,19,17,19,48,155,48,3,19,19,0,0,17
				db	16,0,0,17,16,0,0,2,144

	;}
	;{   A Scene-ek adatai (Automatikusan beemelve!)
	SceneCount		db 	0		; Érvénytelen adatok, csak azért kellenek, hogy a dt_80lib beforduljon
	SceneIndexArray
				dw	0
	SceneBaseAddr
				db	0
	;}


#endasm